package com.hzs.system.sys.service;

import java.util.List;

import com.hzs.common.domain.system.sys.SysRole;
import com.hzs.common.domain.system.sys.SysUser;
import com.hzs.system.sys.param.SysUserParam;
import com.hzs.system.sys.param.SysUserQueryParam;
import com.hzs.system.sys.vo.SysRoleUserVO;
import com.hzs.system.sys.vo.SysUserQueryVO;

/**
 * 用户 业务层
 *
 * @author hzs
 */
public interface ISysUserService {

    /**
     * 根据条件分页查询用户列表
     *
     * @param param
     * @return
     */
    List<SysUserQueryVO> selectUserList(SysUserQueryParam param);

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    SysUser selectUserByUserName(String userName);

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    SysUser selectUserById(Long userId);

    /**
     * 校验用户名称是否唯一
     *
     * @param userName 用户名称
     * @return 结果
     */
    String checkUserNameUnique(String userName);

    /**
     * 校验手机号码是否唯一
     *
     * @param phoneNumber
     * @param userId
     * @return
     */
    String checkPhoneUnique(String phoneNumber, Long userId);

    /**
     * 校验用户是否允许操作
     *
     * @param userId
     */
    void checkUserAllowed(Long userId);

    /**
     * 新增用户信息
     *
     * @param param     管理员入参
     * @param userId
     * @param pkCountry
     * @return
     */
    int insertUser(SysUserParam param, Long userId, Integer pkCountry);

    /**
     * 修改用户信息
     *
     * @param param  管理员入参
     * @param userId
     * @return
     */
    int updateUser(SysUserParam param, Long userId);

    /**
     * 修改用户状态
     *
     * @param user 用户信息
     * @return 结果
     */
    int updateUserStatus(SysUser user);

    /**
     * 修改用户基本信息
     *
     * @param user 用户信息
     * @return 结果
     */
    int updateUserProfile(SysUser user);

    /**
     * 重置用户密码
     *
     * @param user 用户信息
     * @return 结果
     */
    int resetPwd(SysUser user);

    /**
     * 重置用户密码
     *
     * @param userName 用户名
     * @param password 密码
     * @return 结果
     */
    int resetUserPwd(String userName, String password);

    /**
     * 批量删除用户信息
     *
     * @param userIds 需要删除的用户ID
     * @param userId
     * @return 结果
     */
    int deleteUserByIds(Long[] userIds, Long userId);

    /**
     * 根据角色ID查询用户
     *
     * @param roleId
     * @return
     */
    List<SysRoleUserVO> queryUserByRoleId(Long roleId);

    /**
     * 查询会员以及部门名称
     *
     * @param userId
     * @return
     */
    SysUser queryUserAndDeptName(Long userId);


    /**
     * 查询角色用户信息
     *
     * @return List<SysRole>
     */
    List<SysRole> selectSysUserRole(Integer pkCountry);

    /**
     * 查询全部管理员
     *
     * @return
     */
    List<SysUser> selectAll();

}
